diff -u -r linux.clean/drivers/scsi/sr_vendor.c linux.new2/drivers/scsi/sr_vendor.c
--- linux.clean/drivers/scsi/sr_vendor.c	Sun Nov  7 16:35:21 1999
+++ linux.new2/drivers/scsi/sr_vendor.c	Sun Nov 14 10:16:36 1999
@@ -1,5 +1,5 @@
 /* -*-linux-c-*-
- *
+
  * vendor-specific code for SCSI CD-ROM's goes here.
  *
  * This is needed becauce most of the new features (multisession and
@@ -23,15 +23,15 @@
  *   - TOSHIBA: Detection and support of multisession CD's.
  *              Some XA-Sector tweaking, required for older drives.
  *
- *   - SONY:	Detection and support of multisession CD's.
+ *   - SONY:    Detection and support of multisession CD's.
  *              added by Thomas Quinot <thomas@cuivre.freenix.fr>
  *
  *   - PIONEER, HITACHI, PLEXTOR, MATSHITA, TEAC, PHILIPS: known to
  *              work with SONY (SCSI3 now)  code.
  *
- *   - HP:	Much like SONY, but a little different... (Thomas)
+ *   - HP:      Much like SONY, but a little different... (Thomas)
  *              HP-Writers only ??? Maybe other CD-Writers work with this too ?
- *		HP 6020 writers now supported.
+ *              HP 6020 writers now supported.
  */
 
 #include <linux/config.h>
@@ -47,16 +47,16 @@
 #include "sr.h"
 
 #if 0
-# define DEBUG
+#define DEBUG
 #endif
 
 /* here are some constants to sort the vendors into groups */
 
-#define VENDOR_SCSI3           1   /* default: scsi-3 mmc */
+#define VENDOR_SCSI3           1	/* default: scsi-3 mmc */
 
 #define VENDOR_NEC             2
 #define VENDOR_TOSHIBA         3
-#define VENDOR_WRITER          4   /* pre-scsi3 writers */
+#define VENDOR_WRITER          4	/* pre-scsi3 writers */
 
 #define VENDOR_ID (scsi_CDs[minor].vendor)
 
@@ -66,7 +66,7 @@
 	VENDOR_ID = VENDOR_SCSI3;
 #else
 	char *vendor = scsi_CDs[minor].device->vendor;
-	char *model  = scsi_CDs[minor].device->model;
+	char *model = scsi_CDs[minor].device->model;
 
 	/* default */
 	VENDOR_ID = VENDOR_SCSI3;
@@ -77,24 +77,24 @@
 	if (scsi_CDs[minor].device->type == TYPE_WORM) {
 		VENDOR_ID = VENDOR_WRITER;
 
-	} else if (!strncmp (vendor, "NEC", 3)) {
+	} else if (!strncmp(vendor, "NEC", 3)) {
 		VENDOR_ID = VENDOR_NEC;
-		if (!strncmp (model,"CD-ROM DRIVE:25", 15)  ||
-		    !strncmp (model,"CD-ROM DRIVE:36", 15)  ||
-		    !strncmp (model,"CD-ROM DRIVE:83", 15)  ||
-		    !strncmp (model,"CD-ROM DRIVE:84 ",16)
+		if (!strncmp(model, "CD-ROM DRIVE:25", 15) ||
+		    !strncmp(model, "CD-ROM DRIVE:36", 15) ||
+		    !strncmp(model, "CD-ROM DRIVE:83", 15) ||
+		    !strncmp(model, "CD-ROM DRIVE:84 ", 16)
 #if 0
-		        /* my NEC 3x returns the read-raw data if a read-raw
-		           is followed by a read for the same sector - aeb */
-		    || !strncmp (model,"CD-ROM DRIVE:500",16)
+		/* my NEC 3x returns the read-raw data if a read-raw
+		   is followed by a read for the same sector - aeb */
+		    || !strncmp(model, "CD-ROM DRIVE:500", 16)
 #endif
-		   )
+		    )
 			/* these can't handle multisession, may hang */
 			scsi_CDs[minor].cdi.mask |= CDC_MULTI_SESSION;
 
-	} else if (!strncmp (vendor, "TOSHIBA", 7)) {
+	} else if (!strncmp(vendor, "TOSHIBA", 7)) {
 		VENDOR_ID = VENDOR_TOSHIBA;
-		
+
 	}
 #endif
 }
@@ -105,10 +105,10 @@
 
 int sr_set_blocklength(int minor, int blocklength)
 {
-	unsigned char           *buffer;    /* the buffer for the ioctl */
-	unsigned char		cmd[12];    /* the scsi-command */
-	struct ccs_modesel_head	*modesel;
-	int			rc,density = 0;
+	unsigned char *buffer;	/* the buffer for the ioctl */
+	unsigned char cmd[12];	/* the scsi-command */
+	struct ccs_modesel_head *modesel;
+	int rc, density = 0;
 
 #ifdef CONFIG_BLK_DEV_SR_VENDOR
 	if (VENDOR_ID == VENDOR_TOSHIBA)
@@ -116,27 +116,29 @@
 #endif
 
 	buffer = (unsigned char *) scsi_malloc(512);
-	if (!buffer) return -ENOMEM;
+	if (!buffer)
+		return -ENOMEM;
 
 #ifdef DEBUG
-	printk("sr%d: MODE SELECT 0x%x/%d\n",minor,density,blocklength);
+	printk("sr%d: MODE SELECT 0x%x/%d\n", minor, density, blocklength);
 #endif
-	memset(cmd,0,12);
+	memset(cmd, 0, 12);
 	cmd[0] = MODE_SELECT;
 	cmd[1] = (scsi_CDs[minor].device->lun << 5) | (1 << 4);
 	cmd[4] = 12;
-	modesel = (struct ccs_modesel_head*)buffer;
-	memset(modesel,0,sizeof(*modesel));
+	modesel = (struct ccs_modesel_head *) buffer;
+	memset(modesel, 0, sizeof(*modesel));
 	modesel->block_desc_length = 0x08;
-	modesel->density           = density;
-	modesel->block_length_med  = (blocklength >> 8 ) & 0xff;
-	modesel->block_length_lo   =  blocklength        & 0xff;
-	if (0 == (rc = sr_do_ioctl(minor, cmd, buffer, sizeof(*modesel), 0)))
-		scsi_CDs[minor].sector_size = blocklength;
+	modesel->density = density;
+	modesel->block_length_med = (blocklength >> 8) & 0xff;
+	modesel->block_length_lo = blocklength & 0xff;
+	if (0 == (rc = sr_do_ioctl(minor, cmd, buffer, sizeof(*modesel), 0))) {
+		scsi_CDs[minor].device->sector_size = blocklength;
+	}
 #ifdef DEBUG
 	else
 		printk("sr%d: switching blocklength to %d bytes failed\n",
-		       minor,blocklength);
+		       minor, blocklength);
 #endif
 	scsi_free(buffer, 512);
 	return rc;
@@ -149,28 +151,27 @@
 
 int sr_cd_check(struct cdrom_device_info *cdi)
 {
-	unsigned long   sector;
-	unsigned char   *buffer;     /* the buffer for the ioctl */
-	unsigned char   cmd[12];     /* the scsi-command */
-	int             rc,no_multi,minor;
+	unsigned long sector;
+	unsigned char *buffer;	/* the buffer for the ioctl */
+	unsigned char cmd[12];	/* the scsi-command */
+	int rc, no_multi, minor;
 
 	minor = MINOR(cdi->dev);
 	if (scsi_CDs[minor].cdi.mask & CDC_MULTI_SESSION)
 		return 0;
-	
-	spin_lock_irq(&io_request_lock);
+
 	buffer = (unsigned char *) scsi_malloc(512);
-	spin_unlock_irq(&io_request_lock);
-	if(!buffer) return -ENOMEM;
-	
-	sector   = 0;         /* the multisession sector offset goes here  */
-	no_multi = 0;         /* flag: the drive can't handle multisession */
-	rc       = 0;
-    
-	switch(VENDOR_ID) {
-	
+	if (!buffer)
+		return -ENOMEM;
+
+	sector = 0;		/* the multisession sector offset goes here  */
+	no_multi = 0;		/* flag: the drive can't handle multisession */
+	rc = 0;
+
+	switch (VENDOR_ID) {
+
 	case VENDOR_SCSI3:
-		memset(cmd,0,12);
+		memset(cmd, 0, 12);
 		cmd[0] = READ_TOC;
 		cmd[1] = (scsi_CDs[minor].device->lun << 5);
 		cmd[8] = 12;
@@ -180,70 +181,70 @@
 			break;
 		if ((buffer[0] << 8) + buffer[1] < 0x0a) {
 			printk(KERN_INFO "sr%d: Hmm, seems the drive "
-			       "doesn't support multisession CD's\n",minor);
+			   "doesn't support multisession CD's\n", minor);
 			no_multi = 1;
 			break;
 		}
 		sector = buffer[11] + (buffer[10] << 8) +
-			(buffer[9] << 16) + (buffer[8] << 24);
+		    (buffer[9] << 16) + (buffer[8] << 24);
 		if (buffer[6] <= 1) {
 			/* ignore sector offsets from first track */
 			sector = 0;
 		}
 		break;
-		
+
 #ifdef CONFIG_BLK_DEV_SR_VENDOR
-	case VENDOR_NEC: {
-		unsigned long min,sec,frame;
-		memset(cmd,0,12);
-		cmd[0] = 0xde;
-		cmd[1] = (scsi_CDs[minor].device->lun << 5) | 0x03;
-		cmd[2] = 0xb0;
-		rc = sr_do_ioctl(minor, cmd, buffer, 0x16, 1);
-		if (rc != 0)
-			break;
-		if (buffer[14] != 0 && buffer[14] != 0xb0) {
-			printk(KERN_INFO "sr%d: Hmm, seems the cdrom "
-			       "doesn't support multisession CD's\n",minor);
-			no_multi = 1;
+	case VENDOR_NEC:{
+			unsigned long min, sec, frame;
+			memset(cmd, 0, 12);
+			cmd[0] = 0xde;
+			cmd[1] = (scsi_CDs[minor].device->lun << 5) | 0x03;
+			cmd[2] = 0xb0;
+			rc = sr_do_ioctl(minor, cmd, buffer, 0x16, 1);
+			if (rc != 0)
+				break;
+			if (buffer[14] != 0 && buffer[14] != 0xb0) {
+				printk(KERN_INFO "sr%d: Hmm, seems the cdrom "
+				       "doesn't support multisession CD's\n", minor);
+				no_multi = 1;
+				break;
+			}
+			min = BCD_TO_BIN(buffer[15]);
+			sec = BCD_TO_BIN(buffer[16]);
+			frame = BCD_TO_BIN(buffer[17]);
+			sector = min * CD_SECS * CD_FRAMES + sec * CD_FRAMES + frame;
 			break;
 		}
-		min    = BCD_TO_BIN(buffer[15]);
-		sec    = BCD_TO_BIN(buffer[16]);
-		frame  = BCD_TO_BIN(buffer[17]);
-		sector = min*CD_SECS*CD_FRAMES + sec*CD_FRAMES + frame;
-		break;
-	}
 
-	case VENDOR_TOSHIBA: {
-		unsigned long min,sec,frame;
+	case VENDOR_TOSHIBA:{
+			unsigned long min, sec, frame;
 
-		/* we request some disc information (is it a XA-CD ?,
-		 * where starts the last session ?) */
-		memset(cmd,0,12);
-		cmd[0] = 0xc7;
-		cmd[1] = (scsi_CDs[minor].device->lun << 5) | 3;
-		rc = sr_do_ioctl(minor, cmd, buffer, 4, 1);
-		if (rc == -EINVAL) {
-			printk(KERN_INFO "sr%d: Hmm, seems the drive "
-			       "doesn't support multisession CD's\n",minor);
-			no_multi = 1;
+			/* we request some disc information (is it a XA-CD ?,
+			 * where starts the last session ?) */
+			memset(cmd, 0, 12);
+			cmd[0] = 0xc7;
+			cmd[1] = (scsi_CDs[minor].device->lun << 5) | 3;
+			rc = sr_do_ioctl(minor, cmd, buffer, 4, 1);
+			if (rc == -EINVAL) {
+				printk(KERN_INFO "sr%d: Hmm, seems the drive "
+				       "doesn't support multisession CD's\n", minor);
+				no_multi = 1;
+				break;
+			}
+			if (rc != 0)
+				break;
+			min = BCD_TO_BIN(buffer[1]);
+			sec = BCD_TO_BIN(buffer[2]);
+			frame = BCD_TO_BIN(buffer[3]);
+			sector = min * CD_SECS * CD_FRAMES + sec * CD_FRAMES + frame;
+			if (sector)
+				sector -= CD_MSF_OFFSET;
+			sr_set_blocklength(minor, 2048);
 			break;
 		}
-		if (rc != 0)
-			break;
-		min    = BCD_TO_BIN(buffer[1]);
-		sec    = BCD_TO_BIN(buffer[2]);
-		frame  = BCD_TO_BIN(buffer[3]);
-		sector = min*CD_SECS*CD_FRAMES + sec*CD_FRAMES + frame;
-		if (sector)
-			sector -= CD_MSF_OFFSET;
-		sr_set_blocklength(minor,2048);
-		break;
-	}
 
 	case VENDOR_WRITER:
-		memset(cmd,0,12);
+		memset(cmd, 0, 12);
 		cmd[0] = READ_TOC;
 		cmd[1] = (scsi_CDs[minor].device->lun << 5);
 		cmd[8] = 0x04;
@@ -253,31 +254,29 @@
 			break;
 		}
 		if ((rc = buffer[2]) == 0) {
-			printk (KERN_WARNING
-				"sr%d: No finished session\n",minor);
+			printk(KERN_WARNING
+			       "sr%d: No finished session\n", minor);
 			break;
 		}
-
-		cmd[0] = READ_TOC; /* Read TOC */
+		cmd[0] = READ_TOC;	/* Read TOC */
 		cmd[1] = (scsi_CDs[minor].device->lun << 5);
-		cmd[6] = rc & 0x7f;  /* number of last session */
+		cmd[6] = rc & 0x7f;	/* number of last session */
 		cmd[8] = 0x0c;
 		cmd[9] = 0x40;
-		rc = sr_do_ioctl(minor, cmd, buffer, 12, 1);	
+		rc = sr_do_ioctl(minor, cmd, buffer, 12, 1);
 		if (rc != 0) {
 			break;
 		}
-
 		sector = buffer[11] + (buffer[10] << 8) +
-			(buffer[9] << 16) + (buffer[8] << 24);
+		    (buffer[9] << 16) + (buffer[8] << 24);
 		break;
-#endif /* CONFIG_BLK_DEV_SR_VENDOR */
+#endif				/* CONFIG_BLK_DEV_SR_VENDOR */
 
 	default:
 		/* should not happen */
 		printk(KERN_WARNING
-		       "sr%d: unknown vendor code (%i), not initialized ?\n",
-		       minor,VENDOR_ID);
+		   "sr%d: unknown vendor code (%i), not initialized ?\n",
+		       minor, VENDOR_ID);
 		sector = 0;
 		no_multi = 1;
 		break;
@@ -286,16 +285,17 @@
 	scsi_CDs[minor].xa_flag = 0;
 	if (CDS_AUDIO != sr_disk_status(cdi) && 1 == sr_is_xa(minor))
 		scsi_CDs[minor].xa_flag = 1;
-	
-	if (2048 != scsi_CDs[minor].sector_size)
-		sr_set_blocklength(minor,2048);
+
+	if (2048 != scsi_CDs[minor].device->sector_size) {
+		sr_set_blocklength(minor, 2048);
+	}
 	if (no_multi)
 		cdi->mask |= CDC_MULTI_SESSION;
 
 #ifdef DEBUG
 	if (sector)
 		printk(KERN_DEBUG "sr%d: multisession offset=%lu\n",
-		       minor,sector);
+		       minor, sector);
 #endif
 	scsi_free(buffer, 512);
 	return rc;
diff -u -r linux.clean/drivers/scsi/st.c linux.new2/drivers/scsi/st.c
--- linux.clean/drivers/scsi/st.c	Sun Nov  7 16:33:52 1999
+++ linux.new2/drivers/scsi/st.c	Sun Nov 14 09:01:03 1999
@@ -286,15 +286,13 @@
  st_do_scsi(Scsi_Cmnd * SCpnt, Scsi_Tape * STp, unsigned char *cmd, int bytes,
 	    int timeout, int retries, int do_wait)
 {
-	unsigned long flags;
 	unsigned char *bp;
 
-	spin_lock_irqsave(&io_request_lock, flags);
 	if (SCpnt == NULL)
-		if ((SCpnt = scsi_allocate_device(NULL, STp->device, 1)) == NULL) {
+		SCpnt = scsi_allocate_device(STp->device, 1);
+		if (SCpnt == NULL) {
 			printk(KERN_ERR "st%d: Can't get SCSI request.\n",
                                TAPE_NR(STp->devt));
-			spin_unlock_irqrestore(&io_request_lock, flags);
 			return NULL;
 		}
 
@@ -315,7 +313,6 @@
 
 	scsi_do_cmd(SCpnt, (void *) cmd, bp, bytes,
 		    st_sleep_done, timeout, retries);
-	spin_unlock_irqrestore(&io_request_lock, flags);
 
 	if (do_wait) {
 		down(SCpnt->request.sem);
diff -u -r linux.clean/include/linux/blk.h linux.new2/include/linux/blk.h
--- linux.clean/include/linux/blk.h	Tue Oct 19 19:56:18 1999
+++ linux.new2/include/linux/blk.h	Sun Nov 14 08:35:50 1999
@@ -157,9 +157,7 @@
 #elif (SCSI_DISK_MAJOR(MAJOR_NR))
 
 #define DEVICE_NAME "scsidisk"
-#define DEVICE_INTR do_sd  
 #define TIMEOUT_VALUE (2*HZ)
-#define DEVICE_REQUEST do_sd_request
 #define DEVICE_NR(device) (((MAJOR(device) & SD_MAJOR_MASK) << (8 - 4)) + (MINOR(device) >> 4))
 #define DEVICE_ON(device)
 #define DEVICE_OFF(device)
@@ -184,8 +182,6 @@
 #elif (MAJOR_NR == SCSI_CDROM_MAJOR)
 
 #define DEVICE_NAME "CD-ROM"
-#define DEVICE_INTR do_sr
-#define DEVICE_REQUEST do_sr_request
 #define DEVICE_NR(device) (MINOR(device))
 #define DEVICE_ON(device)
 #define DEVICE_OFF(device)
@@ -387,7 +383,7 @@
 #if !defined(IDE_DRIVER)
 
 #ifndef CURRENT
-#define CURRENT (blk_dev[MAJOR_NR].current_request)
+#define CURRENT (blk_dev[MAJOR_NR].request_queue.current_request)
 #endif
 
 #ifndef DEVICE_NAME
@@ -421,7 +417,9 @@
 
 #endif /* DEVICE_TIMEOUT */
 
-static void (DEVICE_REQUEST)(void);
+#ifdef DEVICE_REQUEST
+static void (DEVICE_REQUEST)(request_queue_t *);
+#endif 
   
 #ifdef DEVICE_INTR
 #define CLEAR_INTR SET_INTR(NULL)
diff -u -r linux.clean/include/linux/blkdev.h linux.new2/include/linux/blkdev.h
--- linux.clean/include/linux/blkdev.h	Sun Nov  7 16:35:24 1999
+++ linux.new2/include/linux/blkdev.h	Sun Nov  7 16:57:12 1999
@@ -27,6 +27,7 @@
 	unsigned long nr_sectors;
 	unsigned long nr_segments;
 	unsigned long current_nr_sectors;
+        void * special;
 	char * buffer;
 	struct semaphore * sem;
 	struct buffer_head * bh;
@@ -34,19 +35,57 @@
 	struct request * next;
 };
 
-typedef void (request_fn_proc) (void);
-typedef struct request ** (queue_proc) (kdev_t dev);
+typedef struct request_queue request_queue_t;
+typedef int (merge_request_fn) (request_queue_t *, 
+				struct request  * req,
+				struct buffer_head *);
+typedef int (merge_requests_fn) (request_queue_t *, 
+				 struct request  * req,
+				 struct request  * req2);
+typedef void (request_fn_proc) (request_queue_t *);
+typedef request_queue_t * (queue_proc) (kdev_t dev);
+
+struct request_queue
+{
+	struct request		* current_request;
+	request_fn_proc		* request_fn;
+	merge_request_fn	* merge_fn;
+	merge_requests_fn	* merge_requests_fn;
+	/*
+	 * The queue owner gets to use this for whatever they like.
+	 * ll_rw_blk doesn't touch it.
+	 */
+	void                    * queuedata;
+
+	/*
+	 * This is used to remove the plug when tq_disk runs.
+	 */
+	struct tq_struct          plug_tq;
+	/*
+	 * Boolean that indicates whether this queue is plugged or not.
+	 */
+	char			  plugged;
+
+	/*
+	 * Boolean that indicates whether current_request is active or
+	 * not.
+	 */
+	char			  head_active;
+
+	/*
+	 * Boolean that indicates whether we should use plugging on
+	 * this queue or not.
+	 */
+	char			  use_plug; 
+};
 
 struct blk_dev_struct {
-	request_fn_proc		*request_fn;
 	/*
 	 * queue_proc has to be atomic
 	 */
+	request_queue_t		request_queue;
 	queue_proc		*queue;
 	void			*data;
-	struct request		*current_request;
-	struct request   plug;
-	struct tq_struct plug_tq;
 };
 
 struct sec_size {
@@ -54,12 +93,28 @@
 	unsigned block_size_bits;
 };
 
+/*
+ * Used to indicate the default queue for drivers that don't bother
+ * to implement multiple queues.  We have this access macro here
+ * so as to eliminate the need for each and every block device
+ * driver to know about the internal structure of blk_dev[].
+ */
+#define BLK_DEFAULT_QUEUE(_MAJOR)  &blk_dev[_MAJOR].request_queue
+
 extern struct sec_size * blk_sec[MAX_BLKDEV];
 extern struct blk_dev_struct blk_dev[MAX_BLKDEV];
 extern wait_queue_head_t wait_for_request;
 extern void resetup_one_dev(struct gendisk *dev, int drive);
 extern void unplug_device(void * data);
 extern void make_request(int major,int rw, struct buffer_head * bh);
+
+/*
+ * Access functions for manipulating queue properties
+ */
+extern void blk_init_queue(request_queue_t *, request_fn_proc *);
+extern void blk_cleanup_queue(request_queue_t *);
+extern void blk_queue_headactive(request_queue_t *, int);
+extern void blk_queue_pluggable(request_queue_t *, int);
 
 /* md needs this function to remap requests */
 extern int md_map (int minor, kdev_t *rdev, unsigned long *rsector, unsigned long size);
diff -u -r linux.clean/include/linux/fs.h linux.new2/include/linux/fs.h
--- linux.clean/include/linux/fs.h	Sun Nov  7 16:35:24 1999
+++ linux.new2/include/linux/fs.h	Sun Nov  7 16:56:44 1999
@@ -62,6 +62,7 @@
 #define READ 0
 #define WRITE 1
 #define READA 2		/* read-ahead  - don't block if no resources */
+#define SPECIAL 4	/* For non-blockdevice requests in request queue */
 
 #define WRITERAW 5	/* raw write - don't play with buffer lists */
 
diff -u -r linux.clean/include/linux/ide.h linux.new2/include/linux/ide.h
--- linux.clean/include/linux/ide.h	Sun Nov  7 16:35:24 1999
+++ linux.new2/include/linux/ide.h	Sun Nov  7 17:00:09 1999
@@ -231,7 +231,7 @@
 	} special_t;
 
 typedef struct ide_drive_s {
-	struct request		*queue;	/* request queue */
+	request_queue_t		 queue;	/* request queue */
 	struct ide_drive_s 	*next;	/* circular list of hwgroup drives */
 	unsigned long sleep;		/* sleep until this time */
 	unsigned long service_start;	/* time we started last request */
@@ -728,7 +728,7 @@
 /*
  * ide_get_queue() returns the queue which corresponds to a given device.
  */
-struct request **ide_get_queue (kdev_t dev);
+request_queue_t *ide_get_queue (kdev_t dev);
 
 /*
  * CompactFlash cards and their brethern pretend to be removable hard disks,
@@ -741,33 +741,33 @@
 void ide_timer_expiry (unsigned long data);
 void ide_intr (int irq, void *dev_id, struct pt_regs *regs);
 void ide_geninit (struct gendisk *gd);
-void do_ide0_request (void);
+void do_ide0_request (request_queue_t * q);
 #if MAX_HWIFS > 1
-void do_ide1_request (void);
+void do_ide1_request (request_queue_t * q);
 #endif
 #if MAX_HWIFS > 2
-void do_ide2_request (void);
+void do_ide2_request (request_queue_t * q);
 #endif
 #if MAX_HWIFS > 3
-void do_ide3_request (void);
+void do_ide3_request (request_queue_t * q);
 #endif
 #if MAX_HWIFS > 4
-void do_ide4_request (void);
+void do_ide4_request (request_queue_t * q);
 #endif
 #if MAX_HWIFS > 5
-void do_ide5_request (void);
+void do_ide5_request (request_queue_t * q);
 #endif
 #if MAX_HWIFS > 6
-void do_ide6_request (void);
+void do_ide6_request (request_queue_t * q);
 #endif
 #if MAX_HWIFS > 7
-void do_ide7_request (void);
+void do_ide7_request (request_queue_t * q);
 #endif
 #if MAX_HWIFS > 8
-void do_ide8_request (void);
+void do_ide8_request (request_queue_t * q);
 #endif
 #if MAX_HWIFS > 9
-void do_ide9_request (void);
+void do_ide9_request (request_queue_t * q);
 #endif
 void ide_init_subdrivers (void);
 
